## galera-4 26.4.3

=== SConstruct ===
###################################################################
#
# Copyright (C) 2010-2017 Codership Oy <info@codership.com>
#
# SCons build script to build galera libraries
#
# How to control the build with environment variables:
# Set CC       to specify C compiler
# Set CXX      to specify C++ compiler
# Set CPPFLAGS to add non-standard include paths and preprocessor macros
# Set CCFLAGS  to *override* optimization and architecture-specific options
# Set CFLAGS   to supply C compiler options
# Set CXXFLAGS to supply C++ compiler options
# Set LDFLAGS  to *override* linking flags
# Set LIBPATH  to add non-standard linker paths
# Set RPATH    to add rpaths
#
# Some useful CPPFLAGS:
# GCS_SM_DEBUG          - enable dumping of send monitor state and history
# GU_DEBUG_MUTEX        - enable mutex debug instrumentation
# GU_DBUG_ON            - enable sync point macros
#
# Script structure:
# - Help message
# - Default parameters
# - Read commandline options
# - Set up and configure default build environment
# - Set up and configure check unit test build environment
# - Run root SConscript with variant_dir
#
####################################################################

import os
import platform
import string
import subprocess

# Execute a command and read the first line of its stdout.
# For example read_first_line(["ls", "-l", "/usr"])
def read_first_line(cmd):
    p = subprocess.Popen(cmd, stdout=subprocess.PIPE)
    stdout = p.communicate()[0]
    line = stdout.splitlines()[0]
    return line

sysname = os.uname()[0].lower()
machine = platform.machine()
bits = ARGUMENTS.get('bits', platform.architecture()[0])
print('Host: ' + sysname + ' ' + machine + ' ' + bits)

x86 = any(arch in machine for arch in [ 'x86', 'amd64', 'i686', 'i386', 'i86pc' ])

if bits == '32bit':
    bits = 32
elif bits == '64bit':
    bits = 64

#
# Print Help
#

Help('''
Build targets:  build tests check install all
Default target: all

Commandline Options:
    debug=n             debug build with optimization level n
    build_dir=dir       build directory, default: '.'
    boost=[0|1]         disable or enable boost libraries
    system_asio=[0|1]   use system asio library, if available
    boost_pool=[0|1]    use or not use boost pool allocator
    revno=XXXX          source code revision number
    bpostatic=path      a path to static libboost_program_options.a
    extra_sysroot=path  a path to extra development environment (Fink, Homebrew, MacPorts, MinGW)
    version=X.X.X       galera version
    bits=[32bit|64bit]
    gcov=[True|False]   compile Galera for code coverage reporting
''')
# bpostatic option added on Percona request

#
# Default params
#

build_target = 'all'

# Optimization level
opt_flags    = ' -g -O3 -DNDEBUG'

# Architecture (defaults to build host type)
compile_arch = ''
link_arch    = ''

# Build directory
build_dir    = ''

# Version script file
galera_script = File('#/galera-sym.map').abspath
with open(galera_script, 'w') as f:
    f.write('''{
    global: wsrep_loader;
            wsrep_interface_version;
    local:  *;
};
''')


#
# Read commandline options
#

build_dir = ARGUMENTS.get('build_dir', '')

# Debug/dbug flags
debug = ARGUMENTS.get('debug', -1)
dbug  = ARGUMENTS.get('dbug', False)

gcov = ARGUMENTS.get('gcov', False)

debug_lvl = int(debug)
if debug_lvl >= 0 and debug_lvl < 3:
    opt_flags = ' -g -O%d -fno-inline' % debug_lvl
    dbug = True
elif debug_lvl == 3:
    opt_flags = ' -g -O3'

if dbug:
    opt_flags = opt_flags + ' -DGU_DBUG_ON'

if gcov:
    opt_flags = opt_flags + ' --coverage -g'

if sysname == 'sunos':
    compile_arch = ' -mtune=native'
elif x86:
    if bits == 32:
        if machine == 'x86_64':
            compile_arch = ' -mx32'
        else:
            compile_arch = ' -m32 -march=i686'
            if sysname == 'linux':
                link_arch = ' -Wl,-melf_i386'
    else:
        if machine == 'ppc64':
          compile_arch = ' -mtune=native'
          link_arch = ' -Wl,-melf64ppc'
        elif machine == 'ppc64le':
          compile_arch = ' -mtune=native'
          link_arch = ' -Wl,-melf64lppc'
        else:
          compile_arch = ' -m64'
          if sysname == 'linux':
            link_arch = ' -Wl,-melf_x86_64'
        link_arch = compile_arch + link_arch
elif machine == 's390x':
    compile_arch = ' -mzarch'
    if bits == 32:
        compile_arch += ' -m32'

boost      = int(ARGUMENTS.get('boost', 1))
boost_pool = int(ARGUMENTS.get('boost_pool', 0))
system_asio= int(ARGUMENTS.get('system_asio', 1))
tests      = int(ARGUMENTS.get('tests', 1))
deterministic_tests = int(ARGUMENTS.get('deterministic_tests', 0))
strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 0))


GALERA_VER = ARGUMENTS.get('version', '4.3')
GALERA_REV = ARGUMENTS.get('revno', 'XXXX')

# Attempt to read from file if not given
if GALERA_REV == "XXXX" and os.path.isfile("GALERA_REVISION"):
    f = open("GALERA_REVISION", "r")
    try:
        GALERA_REV = f.readline().rstrip("\n")
    finally:
        f.close()

# export to any module that might have use of those
Export('GALERA_VER', 'GALERA_REV')
print('Signature: version: ' + GALERA_VER + ', revision: ' + GALERA_REV)

LIBBOOST_PROGRAM_OPTIONS_A = ARGUMENTS.get('bpostatic', '')
LIBBOOST_SYSTEM_A = LIBBOOST_PROGRAM_OPTIONS_A.replace('boost_program_options', 'boost_system')

#
# Set up and export default build environment
#

env = Environment(ENV = {'PATH' : os.environ['PATH'], 'HOME' : os.environ['HOME']})

# Set up environment for ccache and distcc
#env['ENV']['HOME']          = os.environ['HOME']
#env['ENV']['DISTCC_HOSTS']  = os.environ['DISTCC_HOSTS']
#env['ENV']['CCACHE_PREFIX'] = os.environ['CCACHE_PREFIX']
if 'CCACHE_DIR' in os.environ:
    env['ENV']['CCACHE_DIR'] = os.environ['CCACHE_DIR']
if 'CCACHE_CPP2' in os.environ:
    env['ENV']['CCACHE_CPP2'] = os.environ['CCACHE_CPP2']

# Set CC and CXX compilers
cc = os.getenv('CC', 'default')
if cc != 'default':
    env.Replace(CC = cc)
cxx = os.getenv('CXX', 'default')
if cxx != 'default':
    env.Replace(CXX = cxx)
link = os.getenv('LINK', 'default')
if link != 'default':
    env.Replace(LINK = link)

# Get compiler name/version, CXX may be set to "c++" which may be clang or gcc
cc_version = str(read_first_line(env['CC'].split() + ['--version']))
cxx_version = str(read_first_line(env['CXX'].split() + ['--version']))

print('Using C compiler executable: ' + env['CC'])
print('C compiler version is: ' + cc_version)
print('Using C++ compiler executable: ' + env['CXX'])
print('C++ compiler version is: ' + cxx_version)

# Initialize CPPFLAGS and LIBPATH from environment to get user preferences
env.Replace(CPPFLAGS  = os.getenv('CPPFLAGS', ''))
env.Replace(CCFLAGS   = os.getenv('CCFLAGS',  opt_flags + compile_arch))
env.Replace(CFLAGS    = os.getenv('CFLAGS',   ''))
env.Replace(CXXFLAGS  = os.getenv('CXXFLAGS', ''))
env.Replace(LINKFLAGS = os.getenv('LDFLAGS',  link_arch))
env.Replace(LIBPATH   = [os.getenv('LIBPATH', '')])
env.Replace(RPATH     = [os.getenv('RPATH',   '')])

# Set -pthread flag explicitly to make sure that pthreads are
# enabled on all platforms.
env.Append(CCFLAGS = ' -pthread')

# FreeBSD ports are usually installed under /usr/local
if sysname == 'freebsd' or sysname == 'sunos':
    env.Append(LIBPATH = ['/usr/local/lib'])
    env.Append(CPPPATH = ['/usr/local/include'])
if sysname == 'sunos':
    env.Replace(SHLINKFLAGS = '-shared ')

# Add paths is extra_sysroot argument was specified
extra_sysroot = ARGUMENTS.get('extra_sysroot', '')
if sysname == 'darwin' and extra_sysroot == '':
    # common developer environments and paths
    if os.system('which -s port') == 0 and os.path.isfile('/opt/local/bin/port'):
        extra_sysroot = '/opt/local'
    elif os.system('which -s brew') == 0 and os.path.isfile('/usr/local/bin/brew'):
        extra_sysroot = '/usr/local'
    elif os.system('which -s fink') == 0 and os.path.isfile('/sw/bin/fink'):
        extra_sysroot = '/sw'
if extra_sysroot != '':
    env.Append(LIBPATH = [extra_sysroot + '/lib'])
    env.Append(CPPFLAGS = ' -I' + extra_sysroot + '/include')

# print env.Dump()

# Preprocessor flags
if sysname != 'sunos' and sysname != 'darwin' and sysname != 'freebsd':
    env.Append(CPPFLAGS = ' -D_XOPEN_SOURCE=600')
if sysname == 'sunos':
    env.Append(CPPFLAGS = ' -D__EXTENSIONS__')
env.Append(CPPFLAGS = ' -DHAVE_COMMON_H')

# Common C/CXX flags
# These should be kept minimal as they are appended after C/CXX specific flags
env.Append(CCFLAGS = ' -fPIC -Wall -Wextra -Wno-unused-parameter')

# C-specific flags
env.Prepend(CFLAGS = '-std=c99 -fno-strict-aliasing -pipe ')

# CXX-specific flags
# Note: not all 3rd-party libs like '-Wold-style-cast -Weffc++'
#       adding those after checks
env.Prepend(CXXFLAGS = '-Wno-long-long -Wno-deprecated ')
if sysname != 'sunos':
    env.Prepend(CXXFLAGS = '-pipe ')


# Linker flags
# TODO: enable ' -Wl,--warn-common -Wl,--fatal-warnings' after warnings from
# static linking have beed addressed
#
#env.Prepend(LINKFLAGS = '-Wl,--warn-common -Wl,--fatal-warnings ')

if gcov:
   env.Append(LINKFLAGS = '--coverage -g')

#
# Check required headers and libraries (autoconf functionality)
#

#
# Custom tests:
#

def CheckCpp0x(context):
    test_source = """
int main() { return 0; }
"""
    context.Message('Checking if compiler accepts -std=c++0x ... ')
    cxxflags_orig = context.env['CXXFLAGS']
    context.env.Prepend(CXXFLAGS = '-std=c++0x ')
    result = context.TryLink(test_source, '.cpp')
    context.env.Replace(CXXFLAGS = cxxflags_orig)
    context.Result(result)
    return result

def CheckCpp11(context):
    test_source = """
int main() { return 0; }
"""
    context.Message('Checking if compiler accepts -std=c++11 ... ')
    cxxflags_orig = context.env['CXXFLAGS']
    context.env.Prepend(CXXFLAGS = '-std=c++11 ')
    result = context.TryLink(test_source, '.cpp')
    context.env.Replace(CXXFLAGS = cxxflags_orig)
    context.Result(result)
    return result

def CheckSystemASIOVersion(context):
    system_asio_test_source_file = """
#include <asio.hpp>

#define XSTR(x) STR(x)
#define STR(x) #x
#pragma message "Asio version:" XSTR(ASIO_VERSION)
#if ASIO_VERSION < 101008
#error Included asio version is too old
#elif ASIO_VERSION >= 101100
#error Included asio version is too new
#endif

int main()
{
    return 0;
}

"""
    context.Message('Checking ASIO version (>= 1.10.8 and < 1.11.0) ... ')
    result = context.TryLink(system_asio_test_source_file, '.cpp')
    context.Result(result)
    return result

def CheckTr1Array(context):
    test_source = """
#include <tr1/array>
int main() { std::tr1::array<int, 5> a; return 0; }
"""
    context.Message('Checking for std::tr1::array ... ')
    result = context.TryLink(test_source, '.cpp')
    context.Result(result)
    return result

def CheckStdSharedPtr(context):
    test_source = """
#include <memory>
int main() { int n; std::shared_ptr<int> p(&n); return 0; }
"""
    context.Message('Checking for std::shared_ptr ... ')
    result = context.TryLink(test_source, '.cpp')
    context.Result(result)
    return result

def CheckTr1UnorderedMap(context):
    test_source = """
#include <tr1/unordered_map>
int main() { std::tr1::unordered_map<int, int> m; return 0; }
"""
    context.Message('Checking for std::tr1::unordered_map ... ')
    result = context.TryLink(test_source, '.cpp')
    context.Result(result)
    return result

def CheckWeffcpp(context):
    # Some compilers (gcc <= 4.8 at least) produce a bogus warning for the code
    # below when -Weffc++ is used.
    test_source = """
class A {};
class B : public A {};
int main() { return 0; }
"""
    context.Message('Checking whether to enable -Weffc++ ... ')
    cxxflags_orig = context.env['CXXFLAGS']
    context.env.Prepend(CXXFLAGS = '-Weffc++ -Werror ')
    result = context.TryLink(test_source, '.cpp')
    context.env.Replace(CXXFLAGS = cxxflags_orig)
    context.Result(result)
    return result

# advanced SSL features

=== debian/changelog ===
galera-4 (26.4.3-4) unstable; urgency=medium

  [ Otto Kekäläinen ]
  * Remove unused Lintian override binary-file-built-without-LFS-support
  * Enable hardening=+all to fix Lintian warning hardening-no-bindnow
  * Include systemd service definition in Debian packaging
  * Add man page for garb-systemd
  * Add minor systemd service definition fixes
  * Add Rules-Requires-Root definition to control file

  [ Faustin Lammler ]
  * Fix systemd unit and start script

 -- Otto Kekäläinen <otto@debian.org>  Sun, 23 Feb 2020 10:46:37 +0200

galera-4 (26.4.3-3) unstable; urgency=medium

  * No-change, source-only upload after previous binary upload to NEW.

 -- Otto Kekäläinen <otto@debian.org>  Thu, 02 Jan 2020 10:20:27 +0200

galera-4 (26.4.3-2) unstable; urgency=medium

  * Rename galera-arbitrator-4 -> -3 forgotten form previous upload
  * Add proper conflicts/replaces to older Galera versions
  * Extend Salsa-CI tests with upgrade scenarios

 -- Otto Kekäläinen <otto@debian.org>  Mon, 30 Dec 2019 11:56:34 +0200

galera-4 (26.4.3-1) unstable; urgency=medium

  * New upstream version 26.4.3
  * Refresh patches after 26.4.3 import
  * Rename galera-3 -> galera-4 after Galera 4 import

 -- Otto Kekäläinen <otto@debian.org>  Sun, 22 Dec 2019 12:06:07 +0200

galera-3 (25.3.28-2) unstable; urgency=low

  [ Debian Janitor ]
  * Use secure URI in debian/watch.
  * Update standards version to 4.4.1, no changes needed.
  * Bump debhelper from old 9 to 12.
  * Fix field name typos in debian/copyright.
  * Remove obsolete fields Name, Contact from debian/upstream/metadata.

 -- Otto Kekäläinen <otto@debian.org>  Mon, 16 Dec 2019 21:32:17 +0200

galera-3 (25.3.28-1) unstable; urgency=medium

  * New upstream version 25.3.28 (Closes: #940200)
  * Remove patch for #927846 as it was applied upstream.
  * Mark autopkgtests with new 'superficial' as it applies to this package

 -- Otto Kekäläinen <otto@debian.org>  Mon, 16 Sep 2019 19:17:31 +0300

galera-3 (25.3.27-1) unstable; urgency=medium

  * New upstream version 25.3.27
  * Include full CC-BY-SA-3.0 license in debian/copyright to satisfy Lintian
  * Drop manual dbgsym creation as this is nowadays automatic
  * Apply upstream patch for FTBFS on hppa, hurd and kfreebsd-*
    (Closes: #927846)

 -- Otto Kekäläinen <otto@debian.org>  Sat, 27 Jul 2019 16:33:43 -0300

galera-3 (25.3.26-1) unstable; urgency=medium

  * New upstream version 25.3.26

 -- Otto Kekäläinen <otto@debian.org>  Tue, 23 Apr 2019 13:23:35 +0300

galera-3 (25.3.25-2) unstable; urgency=low

  [ Giovanni Mascellani ]
  * Hopefully fix FTBFS on mipsel (Closes: #920209)

 -- Otto Kekäläinen <otto@debian.org>  Sat, 30 Mar 2019 16:22:23 +0200

galera-3 (25.3.25-1) unstable; urgency=low

  [ Otto Kekäläinen ]
  * New upstream version 25.3.25

  [ Logan Rosen ]
  * Fix FTBFS against system asio by using bundled version instead
    (Closes: #914112)

  [ Samuel Thibault ]
  * Fix FTBFS on hurd-i386 (Closes: #906305)
  * Do not assume timestamps are strictly monotonous (Closes: #856237)
  * Fix FTBFS on kfreebsd (Closes: #906081)

 -- Otto Kekäläinen <otto@debian.org>  Wed, 09 Jan 2019 00:39:48 +0100

galera-3 (25.3.24-1) unstable; urgency=medium

  [ Otto Kekäläinen ]
  * New upstream version 25.3.24
  * Add .gitlab-ci.yml copied from Salsa-CI team's example
  * Add rudimentary autopkgtests
  * Make build reproducible by forcing an empty GNU build-id
  * Explicitly forbid tests if DEB_BUILD_OPTIONS has nocheck
  * Add d/upstream/metadata file
  * Update http -> https addresses where available
  * Add 'terse' support in DEB_BUILD_OPTIONS
  * Replace buildflags.mk with full default.mk dpkg settings
  * Drop usage of _SYSTEMCTL_SKIP_REDIRECT from init script (Closes: #910471)
  * Debian Policy 4.0.1: use priority 'optional' instead of 'extra'

  [ Dimitri John Ledkov ]
  * Do not run testsuite on armhf with arm64 kernel due to bus errors

  [ Daniel Kahn Gillmor ]
  * Modernize debugging symbols

 -- Otto Kekäläinen <otto@debian.org>  Mon, 15 Oct 2018 16:24:30 +0300

galera-3 (25.3.23-1) unstable; urgency=low

  * Update VCS-* links to point to Salsa
  * New upstream version 25.3.23
    - Includes GCC-7 build fix (Closes: #853410)
  * Fix Lintian complaints
  * Use dh --list-missing to detect extra files that might belong in package

 -- Otto Kekäläinen <otto@debian.org>  Sun, 04 Mar 2018 01:12:52 +0200

galera-3 (25.3.22-1) unstable; urgency=low

  * Update download URL and add check authenticity with PGP signature
  * New upstream version 25.3.22
  * Update Debian standards version to to 4.1.1

 -- Otto Kekäläinen <otto@debian.org>  Tue, 21 Nov 2017 11:57:30 +0100

galera-3 (25.3.20-1) unstable; urgency=low

  * Update Vcs-* URLs to use secure connections
  * New upstream release 25.3.20
  * Include patch to avoid unaligned access, which fixes the regression
    in the armhf build (Closes: #855657)

 -- Otto Kekäläinen <otto@debian.org>  Thu, 09 Mar 2017 18:41:42 +0200

galera-3 (25.3.19-2) unstable; urgency=low

  * Backport upstream fix for OpenSSL SSL_R_SHORT_READ

 -- Otto Kekäläinen <otto@debian.org>  Fri, 11 Nov 2016 21:38:04 +0200

galera-3 (25.3.19-1) unstable; urgency=low

  * New upstream release 25.3.19
  * Make garb depend on lsb-base as uses /lib/lsb/init-functions

 -- Otto Kekäläinen <otto@debian.org>  Thu, 10 Nov 2016 23:02:48 +0200

galera-3 (25.3.17-1) unstable; urgency=low

  * New upstream release
    - Fixes a GCC6/C++11 compatibility issue (Closes: #812052)

 -- Otto Kekäläinen <otto@debian.org>  Mon, 15 Aug 2016 21:04:56 +0300

galera-3 (25.3.16-1) unstable; urgency=low

  * New upstream release

 -- Otto Kekäläinen <otto@debian.org>  Mon, 30 May 2016 23:28:41 +0300

galera-3 (25.3.15-1) unstable; urgency=low

  * New upstream release
    - Remove all obsolete patches

 -- Otto Kekäläinen <otto@debian.org>  Wed, 16 Mar 2016 20:37:10 +0200

galera-3 (25.3.14-2~exp1) experimental; urgency=low

  * Update standards version, vcs-link to use https and maintainer e-mail


=== debian/control ===
Source: galera-4
Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
Uploaders: Otto Kekäläinen <otto@debian.org>
Section: database
Priority: optional
Standards-Version: 4.4.1
Rules-Requires-Root: no
Build-Depends: check,
               debhelper-compat (= 12),
               libboost-dev (>= 1.41),
               libboost-program-options-dev (>= 1.41),
               libssl-dev,
               scons (>= 2)
Homepage: http://www.galeracluster.com/
Vcs-Browser: https://salsa.debian.org/mariadb-team/galera-4
Vcs-Git: https://salsa.debian.org/mariadb-team/galera-4.git

Package: galera-4
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Conflicts: galera-3,
           garbd-2,
           garbd2,
           percona-galera-3,
           percona-galera-4,
           percona-xtradb-cluster-galera,
           percona-xtradb-cluster-galera-2.x,
           percona-xtradb-cluster-galera-3.x,
           percona-xtradb-cluster-galera-4.x,
           percona-xtradb-cluster-garbd-2.x,
           percona-xtradb-cluster-garbd-3.x
Provides: galera,
          galera4,
          percona-xtradb-cluster-galera-26,
          wsrep
Breaks: galera
Replaces: galera
Description: Replication framework for transactional applications
 Galera is a fast synchronous multimaster wsrep provider (replication engine)
 for transactional databases and similar applications. For more information
 about wsrep API see https://launchpad.net/wsrep. For a description of Galera
 replication engine see http://galeracluster.com.
 .
 This package contains the Galera library/plugin.

Package: galera-arbitrator-4
Architecture: any
Conflicts: galera-arbitrator-3,
           garbd-2,
           garbd2,
           percona-galera-arbitrator-3,
           percona-galera-arbitrator-4,
           percona-xtradb-cluster-garbd-2.x
Breaks: percona-xtradb-cluster-galera-2.x
Replaces: percona-xtradb-cluster-galera-2.x
Depends: lsb-base (>= 3.0-6),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Galera arbitrator daemon
 Galera is a fast synchronous multimaster wsrep provider (replication engine)
 for transactional databases and similar applications. For more information
 about wsrep API see http://launchpad.net/wsrep. For a description of Galera
 replication engine see http://galeracluster.com.
 .
 This package contains the Galera arbitrator daemon (garbd).

## galera-4 26.4.5

=== SConstruct ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ###################################################################
 #
-# Copyright (C) 2010-2017 Codership Oy <info@codership.com>
+# Copyright (C) 2010-2020 Codership Oy <info@codership.com>
 #
 # SCons build script to build galera libraries
 #
@@ -65,16 +65,18 @@
 
 Commandline Options:
     debug=n             debug build with optimization level n
+    asan=[0|1]          disable or enable ASAN instrumentation
     build_dir=dir       build directory, default: '.'
     boost=[0|1]         disable or enable boost libraries
     system_asio=[0|1]   use system asio library, if available
     boost_pool=[0|1]    use or not use boost pool allocator
     revno=XXXX          source code revision number
     bpostatic=path      a path to static libboost_program_options.a
+    static_ssl=path     a path to static SSL libraries
     extra_sysroot=path  a path to extra development environment (Fink, Homebrew, MacPorts, MinGW)
-    version=X.X.X       galera version
     bits=[32bit|64bit]
     gcov=[True|False]   compile Galera for code coverage reporting
+    install=path        install files under path
 ''')
 # bpostatic option added on Percona request
 
@@ -114,6 +116,7 @@
 # Debug/dbug flags
 debug = ARGUMENTS.get('debug', -1)
 dbug  = ARGUMENTS.get('dbug', False)
+asan = ARGUMENTS.get('asan', 0)
 
 gcov = ARGUMENTS.get('gcov', False)
 
@@ -141,17 +144,10 @@
             if sysname == 'linux':
                 link_arch = ' -Wl,-melf_i386'
     else:
-        if machine == 'ppc64':
-          compile_arch = ' -mtune=native'
-          link_arch = ' -Wl,-melf64ppc'
-        elif machine == 'ppc64le':
-          compile_arch = ' -mtune=native'
-          link_arch = ' -Wl,-melf64lppc'
-        else:
-          compile_arch = ' -m64'
-          if sysname == 'linux':
+        compile_arch = ' -m64'
+        if sysname == 'linux':
             link_arch = ' -Wl,-melf_x86_64'
-        link_arch = compile_arch + link_arch
+    link_arch = compile_arch + link_arch
 elif machine == 's390x':
     compile_arch = ' -mzarch'
     if bits == 32:
@@ -161,20 +157,21 @@
 boost_pool = int(ARGUMENTS.get('boost_pool', 0))
 system_asio= int(ARGUMENTS.get('system_asio', 1))
 tests      = int(ARGUMENTS.get('tests', 1))
+# Run only tests which are known to be deterministic
 deterministic_tests = int(ARGUMENTS.get('deterministic_tests', 0))
+# Run all tests
+all_tests = int(ARGUMENTS.get('all_tests', 0))
 strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 0))
-
-
-GALERA_VER = ARGUMENTS.get('version', '4.3')
+static_ssl = ARGUMENTS.get('static_ssl', None)
+install = ARGUMENTS.get('install', None)
+
+GALERA_VER = ARGUMENTS.get('version', '4.5')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 
 # Attempt to read from file if not given
 if GALERA_REV == "XXXX" and os.path.isfile("GALERA_REVISION"):
-    f = open("GALERA_REVISION", "r")
-    try:
+    with open("GALERA_REVISION", "r") as f:
         GALERA_REV = f.readline().rstrip("\n")
-    finally:
-        f.close()
 
 # export to any module that might have use of those
 Export('GALERA_VER', 'GALERA_REV')
@@ -236,7 +233,7 @@
     env.Append(LIBPATH = ['/usr/local/lib'])
     env.Append(CPPPATH = ['/usr/local/include'])
 if sysname == 'sunos':
-    env.Replace(SHLINKFLAGS = '-shared ')
+   env.Replace(SHLINKFLAGS = '-shared ')
 
 # Add paths is extra_sysroot argument was specified
 extra_sysroot = ARGUMENTS.get('extra_sysroot', '')
@@ -281,9 +278,12 @@
 # static linking have beed addressed
 #
 #env.Prepend(LINKFLAGS = '-Wl,--warn-common -Wl,--fatal-warnings ')
+if int(asan):
+    env.Append(CCFLAGS = ' -fsanitize=address')
+    env.Append(LINKFLAGS = ' -fsanitize=address')
 
 if gcov:
-   env.Append(LINKFLAGS = '--coverage -g')
+    env.Append(LINKFLAGS = '--coverage -g')
 
 #
 # Check required headers and libraries (autoconf functionality)
@@ -381,10 +381,3 @@
 """
     context.Message('Checking whether to enable -Weffc++ ... ')
     cxxflags_orig = context.env['CXXFLAGS']
-    context.env.Prepend(CXXFLAGS = '-Weffc++ -Werror ')
-    result = context.TryLink(test_source, '.cpp')
-    context.env.Replace(CXXFLAGS = cxxflags_orig)
-    context.Result(result)
-    return result
-
-# advanced SSL features

=== debian/changelog ===
galera-4 (26.4.5-1~bpo10+1) buster-backports; urgency=medium

  * No-change backport to Debian Buster.

 -- Otto Kekäläinen <otto@debian.org>  Sun, 28 Jun 2020 19:22:00 +0300

galera-4 (26.4.5-1) unstable; urgency=medium

  * New upstream version 26.4.5. This is the first official release for
    general availability.
  * Remove all patches as they have been applied upstream.

 -- Otto Kekäläinen <otto@debian.org>  Fri, 29 May 2020 23:39:16 +0300

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Otto Kekäläinen <otto@debian.org>
 Section: database
 Priority: optional
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Build-Depends: check,
                debhelper-compat (= 12),

=== debian/rules ===
#!/usr/bin/make -f

# enable Debian Hardening
# see: https://wiki.debian.org/Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_BUILD_HARDENING = 1
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# Use bundled asio, since system asio is too new (> 1.10.8)
SCONS_ARGS += system_asio=0

# Parallel build support as adviced
# at https://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	SCONS_ARGS += -j$(NUMJOBS)
	# Don't use MAKEFLAGS as it has strange 'w' and '--jobserver-fds=3,4' by default
endif

# According to Debian Policy version 4.2.0 builds should be as verbose as
# possible unless 'terse' is specifically passed.
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
	SCONS_ARGS += VERBOSE=1
	export DH_VERBOSE=1
endif

# Tests are run by default sometimes, so explicitly enable or disable them
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
# Bus errors on arm64 kernels prevent running testsuite when building armhf
ifeq (armhf,$(DEB_HOST_ARCH))
	SCONS_ARGS += tests=0 deterministic_tests=0
else
	SCONS_ARGS += tests=1 deterministic_tests=1
endif
else
	SCONS_ARGS += tests=0 deterministic_tests=0
endif

# Use strict compilation flags (ie -Werror) if requested
ifneq (,$(filter strict_build_flags,$(DEB_BUILD_OPTIONS)))
	SCONS_ARGS += strict_build_flags=1
endif

# Some mipsel buildd's are a bit slow and fail tests if they are not
# given enough time
ifeq (mipsel,$(DEB_HOST_ARCH))
        export CK_TIMEOUT_MULTIPLIER=2
endif

override_dh_auto_build:
	# Print build env info to help debug builds on different platforms
	dpkg-architecture
	@echo $(SCONS_ARGS)
	scons $(SCONS_ARGS) || touch FAIL # Print config.log if build fails
	@echo '*****************************************'
	@echo '**  config.log contents for debugging  **'
	@echo '*****************************************'
	@cat config.log
	@echo '*****************************************'
	if [ -f FAIL ]; then exit 1; fi

# Start earlier than MySQL which has value 19
override_dh_installinit-arch:
	dh_installinit -n --name=garb -- defaults 18 22

override_dh_installsystemd:
	dh_installsystemd --name=garb

%:
	dh $@

## galera-4 26.4.6

=== debian/changelog ===
galera-4 (26.4.6-1build1) hirsute; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 12 Dec 2020 13:06:34 +0100

galera-4 (26.4.6-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Submit, Repository.

  [ Otto Kekäläinen ]
  * New upstream version 26.4.6
  * Apply the test timeout multiplier on all architectures
  * Remove d/copyright references to crc32 library now removed upstream
  * Fix arm64 build failure due to crc32 issue
  * Fix i386 builds by forcing Scons to use DEB_HOST_ARCH if available

 -- Otto Kekäläinen <otto@debian.org>  Sat, 07 Nov 2020 20:26:19 +0200

=== debian/rules ===
--- 
+++ 
@@ -1,10 +1,10 @@
 #!/usr/bin/make -f
 
-# enable Debian Hardening
-# see: https://wiki.debian.org/Hardening
+# Enable Debian Hardening
+# https://wiki.debian.org/Hardening
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-export DEB_BUILD_HARDENING = 1
 DPKG_EXPORT_BUILDFLAGS = 1
+# Include all defaults, including buildflags.mk
 include /usr/share/dpkg/default.mk
 
 # Use bundled asio, since system asio is too new (> 1.10.8)
@@ -27,12 +27,12 @@
 
 # Tests are run by default sometimes, so explicitly enable or disable them
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-# Bus errors on arm64 kernels prevent running testsuite when building armhf
-ifeq (armhf,$(DEB_HOST_ARCH))
-	SCONS_ARGS += tests=0 deterministic_tests=0
-else
-	SCONS_ARGS += tests=1 deterministic_tests=1
-endif
+  # Bus errors on arm64 kernels prevent running testsuite when building armhf
+  ifeq (armhf,$(DEB_HOST_ARCH))
+	  SCONS_ARGS += tests=0 deterministic_tests=0
+  else
+	  SCONS_ARGS += tests=1 deterministic_tests=1
+  endif
 else
 	SCONS_ARGS += tests=0 deterministic_tests=0
 endif
@@ -42,11 +42,9 @@
 	SCONS_ARGS += strict_build_flags=1
 endif
 
-# Some mipsel buildd's are a bit slow and fail tests if they are not
-# given enough time
-ifeq (mipsel,$(DEB_HOST_ARCH))
-        export CK_TIMEOUT_MULTIPLIER=2
-endif
+# Some builders (e.g. mipsel/Debian buildd, riscv64/Launchpad, reprotest/Salsa-CI)
+# are slow and fail tests if they are not given enough time, so always extend it
+export CK_TIMEOUT_MULTIPLIER=2
 
 override_dh_auto_build:
 	# Print build env info to help debug builds on different platforms

## galera-4 26.4.7

=== SConstruct ===
--- 
+++ 
@@ -77,6 +77,8 @@
     bits=[32bit|64bit]
     gcov=[True|False]   compile Galera for code coverage reporting
     install=path        install files under path
+    version_script=[0|1] Use version script (default 1)
+    crc32c_no_hardware=[0|1] disable building hardware support for CRC32C
 ''')
 # bpostatic option added on Percona request
 
@@ -97,15 +99,7 @@
 build_dir    = ''
 
 # Version script file
-galera_script = File('#/galera-sym.map').abspath
-with open(galera_script, 'w') as f:
-    f.write('''{
-    global: wsrep_loader;
-            wsrep_interface_version;
-    local:  *;
-};
-''')
-
+galera_script = File('#/galera/src/galera-sym.map').abspath
 
 #
 # Read commandline options
@@ -117,7 +111,6 @@
 debug = ARGUMENTS.get('debug', -1)
 dbug  = ARGUMENTS.get('dbug', False)
 asan = ARGUMENTS.get('asan', 0)
-
 gcov = ARGUMENTS.get('gcov', False)
 
 debug_lvl = int(debug)
@@ -164,8 +157,9 @@
 strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 0))
 static_ssl = ARGUMENTS.get('static_ssl', None)
 install = ARGUMENTS.get('install', None)
-
-GALERA_VER = ARGUMENTS.get('version', '4.5')
+version_script = int(ARGUMENTS.get('version_script', 1))
+
+GALERA_VER = ARGUMENTS.get('version', '4.7')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 
 # Attempt to read from file if not given
@@ -280,6 +274,7 @@
 #env.Prepend(LINKFLAGS = '-Wl,--warn-common -Wl,--fatal-warnings ')
 if int(asan):
     env.Append(CCFLAGS = ' -fsanitize=address')
+    env.Append(CPPFLAGS = ' -DGALERA_WITH_ASAN')
     env.Append(LINKFLAGS = ' -fsanitize=address')
 
 if gcov:
@@ -379,5 +374,3 @@
 class B : public A {};
 int main() { return 0; }
 """
-    context.Message('Checking whether to enable -Weffc++ ... ')
-    cxxflags_orig = context.env['CXXFLAGS']

=== galera/src/CMakeLists.txt ===
#
# Copyright (C) 2020 Codership Oy <info@codership.com>
#

add_library(galera
  mapped_buffer.cpp
  write_set.cpp
  data_set.cpp
  key_set.cpp
  write_set_ng.cpp
  trx_handle.cpp
  key_entry_os.cpp
  wsdb.cpp
  certification.cpp
  galera_service_thd.cpp
  wsrep_params.cpp
  replicator_smm_params.cpp
  gcs_action_source.cpp
  galera_info.cpp
  galera_view.cpp
  replicator.cpp
  ist.cpp
  ist_proto.cpp
  gcs_dummy.cpp
  saved_state.cpp
  replicator_smm.cpp
  replicator_str.cpp
  replicator_smm_stats.cpp
  )

target_include_directories(galera
  PRIVATE
  ${CMAKE_SOURCE_DIR}/wsrep/src
  )

# TODO: Fix.
target_compile_options(galera
  PRIVATE
  -Wno-conversion
  -Wno-unused-parameter
  )

if (GALERA_STATIC)
  target_link_libraries(galera gcs -static-libgcc)
else()
  target_link_libraries(galera gcs)
endif()

add_library(galera_smm_static
  wsrep_provider.cpp
  )

target_compile_definitions(galera_smm_static
  PRIVATE
  -DGALERA_VER="${GALERA_VERSION}"
  -DGALERA_REV="${GALERA_GIT_REVISION}"
  -DGALERA_MULTIMASTER
  )

target_include_directories(galera_smm_static
  PRIVATE
  ${CMAKE_SOURCE_DIR}/wsrep/src
  )

# TODO: Fix.
target_compile_options(galera_smm_static
  PRIVATE
  -Wno-conversion
  -Wno-unused-parameter
  )

target_link_libraries(galera_smm_static galera)

add_library(galera_smm
  MODULE
  wsrep_provider.cpp
  )

set_target_properties(galera_smm PROPERTIES
  LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
  )

target_include_directories(galera_smm
  PRIVATE
  ${CMAKE_SOURCE_DIR}/wsrep/src
  )

target_compile_definitions(galera_smm
  PRIVATE
  -DGALERA_VER="${GALERA_VERSION}"
  -DGALERA_REV="${GALERA_GIT_REVISION}"
  -DGALERA_MULTIMASTER
  )

# TODO: Fix.
target_compile_options(galera_smm
  PRIVATE
  -Wno-conversion
  -Wno-unused-parameter
  )

#
# Post build checks:
# - Check that symbol visibility matches GALERA_VERSION_SCRIPT.
# - Check that SSL linkake matches GALERA_HAVE_SSL and GALERA_STATIC.
#

if (GALERA_VERSION_SCRIPT)
  # Limit symbols visible from Galera DSO.
  # Doing this allows to:
  # - make the ABI more clean and concise
  # - hide symbols from commonly used libraries (boost, asio, etc.), which
  #   binds calls inside the DSO to its own versions of these libraries
  # See: https://akkadia.org/drepper/dsohowto.pdf (section 2.2.5)
  set(GALERA_LINK_OPTIONS
    -Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/galera-sym.map)
  add_custom_command(TARGET galera_smm POST_BUILD
    COMMAND
    sh -c "! objdump -T ${CMAKE_BINARY_DIR}/libgalera_smm.so | grep asio 1> /dev/null"
    COMMENT "Checking library symbol visibility (hidden)"
    VERBATIM)
else()
  set(GALERA_LINK_OPTIONS "")
  add_custom_command(TARGET galera_smm POST_BUILD
    COMMAND
    sh -c "objdump -T ${CMAKE_BINARY_DIR}/libgalera_smm.so | grep asio 1> /dev/null"
    COMMENT "Checking library symbol visibility (not hidden)"
    VERBATIM)
endif()

if (NOT GALERA_WITH_SSL)
  message(STATUS "Building Galera without SSL")
  add_custom_command(TARGET galera_smm POST_BUILD
    COMMAND
    sh -c "! (ldd ${CMAKE_BINARY_DIR}/libgalera_smm.so | grep crypto 1> /dev/null) && ! (ldd ${CMAKE_BINARY_DIR}/libgalera_smm.so | grep ssl 1> /dev/null)"
    COMMENT "Verifying that library is not linked with SSL"
    VERBATIM)
else()
  if (GALERA_STATIC)
    message(STATUS "Building Galera with static SSL")
    add_custom_command(TARGET galera_smm POST_BUILD
      COMMAND
      sh -c "(objdump -t ${CMAKE_BINARY_DIR}/libgalera_smm.so | grep OPENSSL 1> /dev/null) && (objdump -t ${CMAKE_BINARY_DIR}/libgalera_smm.so | grep CRYPTO 1> /dev/null)"
      COMMENT "Verifying that library has OpenSSL linked statically"
      VERBATIM)
  else()
    message(STATUS "Building Galera with SSL")
    add_custom_command(TARGET galera_smm POST_BUILD
      COMMAND
      sh -c "(ldd ${CMAKE_BINARY_DIR}/libgalera_smm.so | grep crypto 1> /dev/null) && (ldd ${CMAKE_BINARY_DIR}/libgalera_smm.so | grep ssl 1> /dev/null)"
      COMMENT "Verifying that library is linked with SSL"
      VERBATIM)
  endif()
endif()

target_link_libraries(galera_smm galera ${GALERA_LINK_OPTIONS})

install(TARGETS galera_smm DESTINATION lib)

=== galerautils/src/CMakeLists.txt ===
#
# Copyright (C) 2020 Codership Oy <info@codership.com>
#

#
# Compile hardware optimized CRC32C code into separate library
# to keep the optimized code isolated.
#
if (GALERA_CRC32C_X86_64)
  set(GALERAUTILS_HW_CRC32C_SOURCES gu_crc32c_x86.c)
elseif (GALERA_CRC32C_ARM64)
  set(GALERAUTILS_HW_CRC32C_SOURCES gu_crc32c_arm64.c)
endif()

if (GALERAUTILS_HW_CRC32C_SOURCES)
  set(GALERAUTILS_HW_CRC32C_LIB galerautils_hw_crc32c)
  add_library(${GALERAUTILS_HW_CRC32C_LIB} ${GALERAUTILS_HW_CRC32C_SOURCES})
  target_compile_options(${GALERAUTILS_HW_CRC32C_LIB}
    PRIVATE
    ${GALERA_CRC32C_COMPILER_FLAG})
endif()

add_library(galerautils
  gu_abort.c
  gu_crc32c.c
  gu_dbug.c
  gu_fifo.c
  gu_lock_step.c
  gu_log.c
  gu_mem.c
  gu_mmh3.c
  gu_spooky.c
  gu_rand.c
  gu_threads.c
  gu_hexdump.c
  gu_to.c
  gu_utils.c
  gu_uuid.c
  gu_backtrace.c
  gu_limits.c
  gu_time.c
  gu_init.c
  )

# TODO: These should be eventually fixed:
# - Wno-unused-parameter
#
# Suppress -Wself-assign which may emit unwanted warnings when
# using byte swapping macros in way like k = gu_le64(k).
#
target_compile_options(galerautils
  PRIVATE
  -Wno-unused-parameter)

target_link_libraries(galerautils
  ${GALERAUTILS_HW_CRC32C_LIB}
  ${GALERA_SYSTEM_LIBS})

add_library(galerautilsxx
  gu_vlq.cpp
  gu_datetime.cpp
  gu_gtid.cpp
  gu_exception.cpp
  gu_hexdump.cpp
  gu_serialize.cpp
  gu_logger.cpp
  gu_regex.cpp
  gu_string_utils.cpp
  gu_uri.cpp
  gu_buffer.cpp
  gu_utils++.cpp
  gu_config.cpp
  gu_fdesc.cpp
  gu_mmap.cpp
  gu_alloc.cpp
  gu_rset.cpp
  gu_resolver.cpp
  gu_histogram.cpp
  gu_stats.cpp
  gu_asio.cpp
  gu_debug_sync.cpp
  gu_thread.cpp
  gu_uuid.cpp
  )

# TODO: Warnings should be fixed.
target_compile_options(galerautilsxx
  PRIVATE
  -Wno-conversion
  -Wno-unused-parameter)

target_link_libraries(galerautilsxx galerautils ${GALERA_SSL_LIBS})

=== galerautils/tests/CMakeLists.txt ===
#
# Copyright (C) 2020 Codership Oy <info@codership.com>
#

#
# C galerautils tests.
#

add_executable(gu_tests
  gu_tests.c
  gu_crc32c_test.c
  gu_mem_test.c
  gu_bswap_test.c
  gu_fnv_test.c
  gu_mmh3_test.c
  gu_spooky_test.c
  gu_hash_test.c
  gu_time_test.c
  gu_fifo_test.c
  gu_uuid_test.c
  gu_dbug_test.c
  gu_lock_step_test.c
  gu_str_test.c
  gu_utils_test.c
  )

# TODO: These should be eventually fixed.
# - Wno-unused-parameter
#
# Suppress -Wself-assign which may emit unwanted warnings when
# using byte swapping macros in way like k = gu_le64(k).
#
target_compile_options(gu_tests
  PRIVATE
  -Wno-unused-parameter
  )

target_link_libraries(gu_tests galerautils ${GALERA_UNIT_TEST_LIBS})

add_test(
  NAME gu_tests
  COMMAND gu_tests
  )

#
# C++ galerautils tests.
#

add_executable(gu_tests++
  gu_atomic_test.cpp
  gu_gtid_test.cpp
  gu_vector_test.cpp
  gu_string_test.cpp
  gu_vlq_test.cpp
  gu_digest_test.cpp
  gu_mem_pool_test.cpp
  gu_alloc_test.cpp
  gu_rset_test.cpp
  gu_string_utils_test.cpp
  gu_uri_test.cpp
  gu_config_test.cpp
  gu_net_test.cpp
  gu_datetime_test.cpp
  gu_histogram_test.cpp
  gu_stats_test.cpp
  gu_thread_test.cpp
  gu_asio_test.cpp
  gu_deqmap_test.cpp
  gu_tests++.cpp
  )

# TODO: These should be eventually fixed.
target_compile_options(gu_tests++
  PRIVATE
  -Wno-conversion
  -Wno-unused-parameter
  )

target_link_libraries(gu_tests++
  galerautilsxx
  ${GALERA_UNIT_TEST_LIBS}
  )

add_test(
  NAME gu_tests++
  COMMAND gu_tests++
  )

#
# Deqmap micro benchmark.
#

add_executable(deqmap_bench deqmap_bench.cpp)

target_compile_options(deqmap_bench
  PRIVATE
  -Wno-conversion)

target_link_libraries(deqmap_bench galerautilsxx rt)

#
# CRC32C micro benchmark.
#
add_executable(crc32c_bench crc32c_bench.cpp)

target_compile_options(crc32c_bench
  PRIVATE
  -Wno-conversion)

target_link_libraries(crc32c_bench galerautilsxx)

#
# Hash implementation micro benchmark.
#

add_executable(avalanche avalanche.c)

target_compile_options(avalanche
  PRIVATE
  -Wno-conversion
  -Wno-unused-parameter)

target_link_libraries(avalanche galerautils)

#
# Test for old TO monitor implementation, should be removed once all of the
# code which uses gu_to module has been removed.
#
add_executable(gu_to_test gu_to_test.c)

target_link_libraries(gu_to_test galerautils)

target_compile_options(gu_to_test
  PRIVATE
  -Wno-conversion)

=== debian/changelog ===
galera-4 (26.4.7-3) unstable; urgency=medium

  * Revised atomics patch to fix multiple FTBFS
  * Update standards-version to 4.5.1 (no changes)

 -- Otto Kekäläinen <otto@debian.org>  Sat, 20 Feb 2021 21:26:46 +0200

galera-4 (26.4.7-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix new CMake definitions to correctly use CMAKE_OBJDUMP (Closes: #981652)

  [ Otto Kekäläinen ]
  * Backport atomics patch from upstream to fix multiple FTBFS

 -- Otto Kekäläinen <otto@debian.org>  Fri, 05 Feb 2021 12:24:44 +0200

galera-4 (26.4.7-1) unstable; urgency=medium

  * New upstream version 26.4.7
  * Remove arm64 crc32 patch that was applied upstream
  * Build with CMake instead of SCons, as now done in upstream
  * Install libgalera_smm.so the only way upstream now does it
  * Also sync all other relevant changes done in debian/ upstream

 -- Otto Kekäläinen <otto@debian.org>  Mon, 01 Feb 2021 18:27:19 +0200

=== debian/control ===
--- 
+++ 
@@ -3,15 +3,15 @@
 Uploaders: Otto Kekäläinen <otto@debian.org>
 Section: database
 Priority: optional
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Build-Depends: check,
+               cmake (>= 2.8),
                debhelper-compat (= 12),
                libboost-dev (>= 1.41),
                libboost-program-options-dev (>= 1.41),
-               libssl-dev,
-               scons (>= 2)
-Homepage: http://www.galeracluster.com/
+               libssl-dev
+Homepage: https://www.galeracluster.com/
 Vcs-Browser: https://salsa.debian.org/mariadb-team/galera-4
 Vcs-Git: https://salsa.debian.org/mariadb-team/galera-4.git
 
@@ -22,7 +22,9 @@
          ${shlibs:Depends}
 Conflicts: galera-3,
            garbd-2,
+           garbd-3,
            garbd2,
+           garbd3,
            percona-galera-3,
            percona-galera-4,
            percona-xtradb-cluster-galera,
@@ -40,8 +42,8 @@
 Description: Replication framework for transactional applications
  Galera is a fast synchronous multimaster wsrep provider (replication engine)
  for transactional databases and similar applications. For more information
- about wsrep API see https://launchpad.net/wsrep. For a description of Galera
- replication engine see http://galeracluster.com.
+ about wsrep API see https://github.com/codership/wsrep-API. For a description
+ of Galera replication engine see http://galeracluster.com.
  .
  This package contains the Galera library/plugin.
 
@@ -61,7 +63,7 @@
 Description: Galera arbitrator daemon
  Galera is a fast synchronous multimaster wsrep provider (replication engine)
  for transactional databases and similar applications. For more information
- about wsrep API see http://launchpad.net/wsrep. For a description of Galera
- replication engine see http://galeracluster.com.
+ about wsrep API see https://github.com/codership/wsrep-API. For a description
+ of Galera replication engine see http://galeracluster.com.
  .
  This package contains the Galera arbitrator daemon (garbd).

=== debian/rules ===
#!/usr/bin/make -f

# Enable Debian Hardening
# https://wiki.debian.org/Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
# Include all defaults, including buildflags.mk
include /usr/share/dpkg/default.mk

override_dh_auto_test:
	dh_auto_test -O--no-parallel -- ARGS=--output-on-failure

# Start earlier than MySQL which has value 19
override_dh_installinit-arch:
	dh_installinit -n --name=garb -- defaults 18 22

override_dh_installsystemd:
	dh_installsystemd --name=garb

%:
	dh $@

## galera-4 26.4.8

=== SConstruct ===
--- 
+++ 
@@ -69,9 +69,11 @@
     build_dir=dir       build directory, default: '.'
     boost=[0|1]         disable or enable boost libraries
     system_asio=[0|1]   use system asio library, if available
+    asio_path=path      path to asio headers
     boost_pool=[0|1]    use or not use boost pool allocator
     revno=XXXX          source code revision number
     bpostatic=path      a path to static libboost_program_options.a
+    ssl=[0|1]           build without/with SSL enabled
     static_ssl=path     a path to static SSL libraries
     extra_sysroot=path  a path to extra development environment (Fink, Homebrew, MacPorts, MinGW)
     bits=[32bit|64bit]
@@ -149,17 +151,19 @@
 boost      = int(ARGUMENTS.get('boost', 1))
 boost_pool = int(ARGUMENTS.get('boost_pool', 0))
 system_asio= int(ARGUMENTS.get('system_asio', 1))
+asio_path  = ARGUMENTS.get('asio_path')
 tests      = int(ARGUMENTS.get('tests', 1))
 # Run only tests which are known to be deterministic
 deterministic_tests = int(ARGUMENTS.get('deterministic_tests', 0))
 # Run all tests
 all_tests = int(ARGUMENTS.get('all_tests', 0))
 strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 0))
+have_ssl = int(ARGUMENTS.get('ssl', 1))
 static_ssl = ARGUMENTS.get('static_ssl', None)
 install = ARGUMENTS.get('install', None)
 version_script = int(ARGUMENTS.get('version_script', 1))
 
-GALERA_VER = ARGUMENTS.get('version', '4.7')
+GALERA_VER = ARGUMENTS.get('version', '4.8')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 
 # Attempt to read from file if not given
@@ -278,7 +282,7 @@
     env.Append(LINKFLAGS = ' -fsanitize=address')
 
 if gcov:
-    env.Append(LINKFLAGS = '--coverage -g')
+    env.Append(LINKFLAGS = ' --coverage -g')
 
 #
 # Check required headers and libraries (autoconf functionality)
@@ -367,10 +371,3 @@
     return result
 
 def CheckWeffcpp(context):
-    # Some compilers (gcc <= 4.8 at least) produce a bogus warning for the code
-    # below when -Weffc++ is used.
-    test_source = """
-class A {};
-class B : public A {};
-int main() { return 0; }
-"""
